<!DOCTYPE html>
<html>
<body>

<h2>JavaScript Promise</h2>

<p>Wait 3 seconds (3000 milliseconds) for this page to change.</p>

<div id="demo"></div>

<script>

async function sleep(ms) {
  // return new Promise(resolve => setTimeout(resolve, ms));
  return new Promise(function(myResolve, myReject){setTimeout(myResolve, ms)})
}

async function myCallbackFunction(myResolve, myReject) {
  await sleep(1000);
  let req = new XMLHttpRequest();  
  req.open('GET', "example.html");
  req.onload = function() {
    if (req.status == 200) {
      myResolve(this.responseText);
    } else {
      myReject(req.status);
    }
  }
  req.send();
}

let myPromise = new Promise(myCallbackFunction);

function myResolveFunction(value) {
  document.getElementById("demo").style.color = "green";
  document.getElementById("demo").innerHTML = value;
}

function myRejectFunction(value) {
  document.getElementById("demo").style.color = "red";
  document.getElementById("demo").innerHTML = "Error: "+value;
}

myPromise.then(myResolveFunction, myRejectFunction);

myResolveFunction("Testing ...");  

</script>

</body>
</html>
